' Save the current sample to restore after
sample smplbackup

' Set sample to  
smpl @first @last

' Get obs number for loop
!datacount = @obs(_this)

' Periods ahead forecast (h) depends on frequency

%pgfreq = @pagefreq

!h = 0

if %pgfreq = "M" then
	!h = 8
endif

if %pgfreq = "Q" then
	!h = 8
endif

if %pgfreq = "A" then
	!h = 8
endif

if !h=0 then
	@uiprompt("Filter only applies to Monthly, Quarterly and Annual data","O")
	stop
endif

' Create name variables for trend and cycle
%cycleoutputname = _this.@name + "_HCycle"
%trendoutputname = _this.@name + "_HTrend"

' Could just use this in regression but specification then breaks when accessed outside the add in
' Using variable name maintains the specification
%inputvarname= _this.@name

' Clean up any already existing output
if @isobject(%cycleoutputname) then
   delete %cycleoutputname
endif

if @isobject(%trendoutputname )then
   delete %trendoutputname 
endif

'Create container variables
series {%cycleoutputname}
series {%trendoutputname }


' Create container name as something random to avoid overriding user equation
equation HamiltonEstimation192873

' Loop to actually estimate the hamilton filter
' Start at five because need five lags of data - go until the end of the dataset

for !i=5 to !datacount - (!h+ 5) step 1 
	
	' Set the sample range for the regression
	smpl @first+!i @first+!i + 5
	
	' Estimate the trend / fitted value equation
	HamiltonEstimation192873.ls {%inputvarname} c {%inputvarname}(-1) {%inputvarname}(-2) {%inputvarname}(-3) {%inputvarname}(-4) 
	
	'Generate the trend with the fitted values from the equation estimation and lags
	{%trendoutputname}(!i + 5 +!h) = c(1) _
				   + c(2) * {%inputvarname}(!i+4)  _
				   + c(3) * {%inputvarname}(!i+3)  _ 
				   + c(4) * {%inputvarname}(!i+2)  _ 
				   + c(5) * {%inputvarname}(!i+1)  
									 
	{%cycleoutputname}(!i + 5 +!h) = {%inputvarname}(!i + 5 +!h) - {%trendoutputname}(!i + 5 +!h)
	
next

' Restore the sample to whatever it was before the add in ran
smpl smplbackup

' Have now created the output series, just need to tidy up working equation and sample backup
delete HamiltonEstimation192873
delete smplbackup

' Show a graph of the output
{%cycleoutputname}.line